function dataHandler(val, oldVal) {
  console.log('handler called...');

  if (!this.$data._chart) {
    this.renderChart(this.chartData, this.options);
  } else if (!this._updatingChart) {
    console.log('unWatching...');

    this._unWatchChartData();

    console.log('updating...');

    this.$data._chart.update();

    console.log('watching...');
    this._unWatchChartData = this.$watch('chartData', dataHandler, {
      deep: true
    });
  }
}

export var reactiveData = {
  data: function data() {
    return {
      _unWatchChartData: null,
      _updatingChart: false,
      chartData: null
    };
  },
  mounted: function mounted() {
    this._unWatchChartData = this.$watch('chartData', dataHandler, {
      deep: true
    });
  }
};
export var reactiveProp = {
  data: function data() {
    return {
      _unWatchChartData: null,
      _updatingChart: false
    };
  },
  props: {
    chartData: {
      required: true
    }
  },
  mounted: function mounted() {
    this._unWatchChartData = this.$watch('chartData', dataHandler, {
      deep: true
    });
  }
};
export default {
  reactiveData: reactiveData,
  reactiveProp: reactiveProp
};